const AdaPay = require('./adaPay.js')
// const AdaPay = require('../../../AdaPay-alipay-SDK/AdaPay')

Page({
  data: {
    user_id: '',
    pay_amt: '' 
  },
  onLoad(query) {
    let self = this
    my.getAuthCode({
      scopes: 'auth_user',
      success: (res) => {
        console.log(res)
        // self.setData({
        //   authCode: res.authCode,
        // })
        self.getUserId(res.authCode)
      },
    });
  },

  // 获取授权拿到用户 userId
  getUserId(authCode) {
    let self = this
    my.request({
      url: 'https://adapay-test-python.cloudpnr.com/api/v1/auth/alipay_lite',
      method: 'POST',
      data: {
        auth_code: authCode,
      },
      success: (res) => {
        console.log("success>>>>>",res)
        let user_id = res.data.user_id

        self.setData({
          user_id: user_id
        })
      },
      fail: function(res) {
        console.log("fail>>>>>",res)
      },
    });
  },

  // 按钮点击事件
  pay() {
    this.creatOrder()
  },

  // 下单请求
  creatOrder() {
    my.showLoading();
    let { pay_amt, user_id } = this.data
    my.request({
      url: 'https://adapay-test-python.cloudpnr.com/api/v1/payment/create',
      data: {
          "pay_amt": pay_amt,
          "app_id": "app_63413c8e-a0f4-4d60-9cbd-5620063d035f",
          "goods_title": "AdaPay 测试",
          "env": "1",
          "prod_mode": "1",
          "pay_channel": "alipay_lite",
          "goods_desc": "AdaPay",
          "merchant_no": "huihan_2",
          "expend": {
              "buyer_id": user_id, //"2088702157320410",
          }
      },
      method: 'POST',
      success(res) {
        let payment = JSON.parse(res.data.data)
        console.log(payment)
        my.hideLoading();
        if (payment.status === 'succeeded') {
          AdaPay.doPay(payment, (res) => {
            console.log(res)
            my.alert({
              title: '支付结果',
              content: res.result_message
            });
          })
        }else{
          my.alert({
            title: '下单失败',
            content: payment.error_msg
          });
        }
        
      },
      fail(error) {
        console.log(error)
      }
    })
  },

  onInput(e) {
    let amount = this.changeTwoDecimal(e.detail.value)
    console.log(amount)

    this.setData({
      pay_amt: amount
    })
  },

  changeTwoDecimal(amt) {
    var f_x = parseFloat(amt);
    if (isNaN(f_x)) {
        return "0.00";
    }
    var f_x = Math.round(f_x * 100) / 100;
    var s_x = f_x.toString();
    var pos_decimal = s_x.indexOf('.');
    if (pos_decimal < 0) {
        pos_decimal = s_x.length;
        s_x += '.';
    }
    while (s_x.length <= pos_decimal + 2) {
        s_x += '0';
    }
    return s_x;
  },

  onShareAppMessage() {
    // 返回自定义分享信息
    return {
      title: 'Ada的小店',
      desc: 'Ada的小店',
      path: 'pages/index/index',
    };
  },
});
